Version bump, import of Enrico Tagliavini's ebuild from the x11 overlay.
authorChí-Thanh Christopher Nguyễn <chithanh@gentoo.org>
Sun, 20 Nov 2011 02:01:26 +0000 (02:01 +0000)
committerChí-Thanh Christopher Nguyễn <chithanh@gentoo.org>
Sun, 20 Nov 2011 02:01:26 +0000 (02:01 +0000)
Package-Manager: portage-2.2.0_alpha72/cvs/Linux x86_64

x11-drivers/ati-drivers/ChangeLog
x11-drivers/ati-drivers/Manifest
x11-drivers/ati-drivers/ati-drivers-11.11.ebuild [new file with mode: 0644]
x11-drivers/ati-drivers/metadata.xml

index 92c9d797e0c3aff253ebbd2e9378a7a98c3f1d26..d20ab17f2dfeef623d4b6966d618b79b5da8fe16 100644 (file)
@@ -1,6 +1,12 @@
 # ChangeLog for x11-drivers/ati-drivers
 # Copyright 1999-2011 Gentoo Foundation; Distributed under the GPL v2
-# $Header: /var/cvsroot/gentoo-x86/x11-drivers/ati-drivers/ChangeLog,v 1.261 2011/10/31 19:34:18 chithanh Exp $
+# $Header: /var/cvsroot/gentoo-x86/x11-drivers/ati-drivers/ChangeLog,v 1.262 2011/11/20 02:01:26 chithanh Exp $
+
+*ati-drivers-11.11 (20 Nov 2011)
+
+  20 Nov 2011; Chí-Thanh Christopher Nguyễn <chithanh@gentoo.org>
+  +ati-drivers-11.11.ebuild, metadata.xml:
+  Version bump, import of Enrico Tagliavini's ebuild from the x11 overlay.
 
 *ati-drivers-11.10 (31 Oct 2011)
 
index c28df229e300d91c8e57cd7e37b615d8e4785a9e..ec5cc15c2f968070de8391684554632b5d2c6f32 100644 (file)
@@ -4,6 +4,7 @@ AUX ati-powermode-opt-path-2.patch 1634 RMD160 a9c4ecc90a748f94282521a555ad7b64d
 AUX atieventsd.init 533 RMD160 b9b95a8a3f32dcafba3e5fa08d6d1053e831291a SHA1 982ffdb8064785c8b96fb0213ad7892ac918b5d7 SHA256 20010ebc5cb286149f3c4c9c099b6470463ccdb8fd47cea054b783dc2ad1fff3
 AUX switchlibGL 1349 RMD160 d3c9f36fabf65b21f26456e303d8127779fd1bd2 SHA1 277a549afd62fdeae9f09022a8e55ceabf180f9f SHA256 a4aa2107fdb903da77fea432bc809a1155e213db460fdec72fd1c3c7cc0d13a0
 DIST ati-driver-installer-11-10-x86.x86_64.run 77926379 RMD160 bef9aa8ff1bd366b5e8505789e87ac268ebc6807 SHA1 406e0a69f1e9dfd899bbcc6fa00d00adfba077cb SHA256 a245e0305051313767fef1be88693702fccfb3f11c18a98f61c233af17e85f9e
+DIST ati-driver-installer-11-11-x86.x86_64.run 97090080 RMD160 07c19b48ccb6d7d95d585545ec3a3038fdfb65bd SHA1 7de856b9464e617fa3b880de6b45ef9ec56e6336 SHA256 fcd51cdc0c7572d443f5ce54576888f09efaced10b12ccf9fa775c81eaade013
 DIST ati-driver-installer-11-4-x86.x86_64.run 75710303 RMD160 983d8ec36c154016c3b6ab172ba2e8cccde4faff SHA1 013d99ee025e1e97d01f6f68475c5a4b1df283cd SHA256 6101bf01c9bec7fab95595c0e19741f3692cc2cfd8e9b905f4f0df5b445ae45e
 DIST ati-driver-installer-11-5-x86.x86_64.run 74585606 RMD160 1ada69dc9d3a4514dc658481e4db34671668b114 SHA1 e715d28bc0e3284b6e06d698fd7f7c547b625707 SHA256 052d496c7931bf201ecd4fce6afc9d8df454ad50f71fd695053b404239296f58
 DIST ati-driver-installer-11-6-x86.x86_64.run 75503458 RMD160 fce2a7c1b7c213f26befc2beab47eefdcfd0059f SHA1 463dba00b419f761db2bf97088e6cfbcfc63c9fa SHA256 3dbb7cf1a5493588d872eb29b7376eb5db3913c4f35d631c3183d168eed1f67f
@@ -11,11 +12,12 @@ DIST ati-driver-installer-11-7-x86.x86_64.run 75416437 RMD160 7f693992598e58ecec
 DIST ati-driver-installer-11-8-x86.x86_64.run 75754239 RMD160 92e33779416228ef75fd8bc8790c5aebd2f3332f SHA1 807a5663b062a9cf6295ac8cf3dee7439aabda57 SHA256 71e0194daef7a50c6d0d3b5712b05375a003d452e39c754278336c3811a2acdf
 DIST ati-driver-installer-11-9-x86.x86_64.run 76564617 RMD160 8631c510ace5a7d73c97064f8ca16ee9a6fe94e4 SHA1 e01caf1211fd3f9602017a340921aa1b9c38b802 SHA256 d9ad9c8e0bd250ac41c39d9b8e9f77efc82631f4bebacb82ddde982a86530d56
 EBUILD ati-drivers-11.10.ebuild 18184 RMD160 b5424f2978fa918fae6d3b91e39fbd5ac73c5055 SHA1 75f9078ed0d9034e582e2ca211cb3626c3c28947 SHA256 5168f7a6f9c86dd0d41fdb2e2390524410c3d2e04d2961de1c8e2606de0beb01
+EBUILD ati-drivers-11.11.ebuild 18699 RMD160 020d07b1bb6a878cda26034058b757f013ee2b05 SHA1 b6d6db75164f93667ed3c2ea2e2bb633b5fb629d SHA256 e5bfc169fc0d3efa49c79648bb74e1913a0af0baade7230c652403085fd84b85
 EBUILD ati-drivers-11.4.ebuild 17519 RMD160 91cc358252f88c4cfaec77384117907853a88791 SHA1 a262db426e121dc401588bb0b691fcf959162f54 SHA256 dc524e9832910ba6d8e75d4dfdcb3c7cf0dbdfe0fde8132f86a99726fe5e2c48
 EBUILD ati-drivers-11.5.ebuild 18366 RMD160 a2ebc6c386c8c92313fa225bb5e10870ba1e4a8e SHA1 e1db1a2241e4e7e7243f658a7d1c16cbeb4f43fd SHA256 9c02162b137b7fc230f0af100ab0c2e2fb53f23fcbe9e34c69589382c5921a2c
 EBUILD ati-drivers-11.6.ebuild 18265 RMD160 d4d528340fd132a07f415e7c1397b1b3e162f2d9 SHA1 927f46c7e994dd40334a5998a9802efdc0042fe5 SHA256 fec6e4cfdee67e42dbf55a31f1f2470d5227f86bdbcd6e433de32bdd0277d2da
 EBUILD ati-drivers-11.7.ebuild 18511 RMD160 b9f27982e72171c63044662562ccbce45e74d177 SHA1 0f43c043578f969475d423c11bcebd053d673b36 SHA256 54de74216f659cd5b1587134b7c0ba4a5b6255f39f63fefa55cfa21fe05b5b4d
 EBUILD ati-drivers-11.8.ebuild 18507 RMD160 424c99bc46a516acc32d0379da7f5fa4ba854646 SHA1 eaccbb3187a55423e5defa93660d595b22dd2c1e SHA256 648d539eae0d9f0c689d5398275d8bf0a777dfc6797eef130b13388da2728ab5
 EBUILD ati-drivers-11.9.ebuild 18169 RMD160 04b4aa7a666db3e0225c60e9272e6ced68bc7732 SHA1 6a5183cbf112c075ea09a3bd9c1840e6742304ae SHA256 dc52aeb4a5d1792ede7c301a3b7cb7159cf266cfe19ed9de5517223e496e84de
-MISC ChangeLog 72631 RMD160 2a41790f0e1d91bf7059aad8410b191f86c11c30 SHA1 8ccd37f7109c37b60d507a8b3586018c4a46c8eb SHA256 65b55ad049018250316f8c90fc4b6f28b3e446af5f8a2c40c35a5ea5b8d8f6db
-MISC metadata.xml 570 RMD160 0a020753d41a48670dccdf8da444e29531426bbb SHA1 4b0d5dace7a76499468fe40c9645ef11ff864776 SHA256 e20880954026ec88b69b99b3015edbfcb3bb3067b693064aecf8770a8cf76072
+MISC ChangeLog 72853 RMD160 3f2fbbe1ff514391b6775cccac60ebc02e34cc01 SHA1 fe453b6c8f87b2003f425c3a1e88e8d55b1cffe4 SHA256 305dd063e7db03c1d56b81cfd3b4c52c89bb5441c9375ce1ad5ad01c6f78c288
+MISC metadata.xml 631 RMD160 4bb276f0a1146ca6da7d80034794c63af1678eb9 SHA1 3b1b9b59e82d5a994b5e225979ef46f668c57fef SHA256 8fccde1e9010a23c674139bfdb1b333d2d2341ea5286b2b8b2ce8a12d502da84
diff --git a/x11-drivers/ati-drivers/ati-drivers-11.11.ebuild b/x11-drivers/ati-drivers/ati-drivers-11.11.ebuild
new file mode 100644 (file)
index 0000000..4c2209f
--- /dev/null
@@ -0,0 +1,588 @@
+# Copyright 1999-2011 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: /var/cvsroot/gentoo-x86/x11-drivers/ati-drivers/ati-drivers-11.11.ebuild,v 1.1 2011/11/20 02:01:26 chithanh Exp $
+
+EAPI=4
+
+inherit eutils multilib linux-info linux-mod toolchain-funcs versionator
+
+DESCRIPTION="Ati precompiled drivers for r600 (HD Series) and newer chipsets"
+HOMEPAGE="http://www.ati.com"
+# 8.ble will be used for beta releases.
+if [[ $(get_major_version) -gt 8 ]]; then
+       ATI_URL="http://www2.ati.com/drivers/linux/"
+       SRC_URI="${ATI_URL}/ati-driver-installer-${PV/./-}-x86.x86_64.run"
+       FOLDER_PREFIX="common/"
+else
+       SRC_URI="https://launchpad.net/ubuntu/natty/+source/fglrx-installer/2:${PV}-0ubuntu1/+files/fglrx-installer_${PV}.orig.tar.gz"
+       FOLDER_PREFIX=""
+fi
+IUSE="debug +modules multilib opencl qt4"
+
+LICENSE="AMD GPL-2 QPL-1.0 as-is"
+KEYWORDS="~amd64 ~x86"
+SLOT="1"
+
+RDEPEND="
+       <=x11-base/xorg-server-1.11.49
+       >=app-admin/eselect-opengl-1.0.7
+       sys-power/acpid
+       x11-apps/xauth
+       x11-libs/libX11
+       x11-libs/libXext
+       x11-libs/libXinerama
+       x11-libs/libXrandr
+       x11-libs/libXrender
+       multilib? ( app-emulation/emul-linux-x86-opengl )
+       qt4? (
+                       x11-libs/libICE
+                       x11-libs/libSM
+                       x11-libs/libXcursor
+                       x11-libs/libXfixes
+                       x11-libs/libXxf86vm
+                       x11-libs/qt-core
+                       x11-libs/qt-gui
+       )
+"
+
+DEPEND="${RDEPEND}
+       app-portage/portage-utils
+       x11-proto/inputproto
+       x11-proto/xf86miscproto
+       x11-proto/xf86vidmodeproto
+       x11-proto/xineramaproto
+       x11-libs/libXtst
+       sys-apps/findutils
+       app-misc/pax-utils
+"
+
+EMULTILIB_PKG="true"
+
+S="${WORKDIR}"
+
+# QA Silencing
+QA_TEXTRELS="
+       usr/lib*/opengl/ati/lib/libGL.so.1.2
+       usr/lib*/libatiadlxx.so
+       usr/lib*/xorg/modules/glesx.so
+       usr/lib*/libaticaldd.so
+       usr/lib*/dri/fglrx_dri.so
+"
+
+QA_EXECSTACK="
+       opt/bin/atiode
+       opt/bin/amdcccle
+       usr/lib*/opengl/ati/lib/libGL.so.1.2
+       usr/lib*/dri/fglrx_dri.so
+"
+
+QA_WX_LOAD="
+       usr/lib*/opengl/ati/lib/libGL.so.1.2
+       usr/lib*/dri/fglrx_dri.so
+"
+
+QA_PRESTRIPPED="
+       usr/lib\(32\|64\)\?/libXvBAW.so.1.0
+       usr/lib\(32\|64\)\?/opengl/ati/lib/libGL.so.1.2
+       usr/lib\(32\|64\)\?/opengl/ati/extensions/libglx.so
+       usr/lib\(32\|64\)\?/xorg/modules/glesx.so
+       usr/lib\(32\|64\)\?/libAMDXvBA.so.1.0
+       usr/lib\(32\|64\)\?/libaticaldd.so
+       usr/lib\(32\|64\)\?/dri/fglrx_dri.so
+"
+
+QA_SONAME="
+       usr/lib\(32\|64\)\?/libatiadlxx.so
+       usr/lib\(32\|64\)\?/libaticalcl.so
+       usr/lib\(32\|64\)\?/libaticaldd.so
+       usr/lib\(32\|64\)\?/libaticalrt.so
+       usr/lib\(32\|64\)\?/libamdocl\(32\|64\)\?.so
+"
+
+QA_DT_HASH="
+       opt/bin/amdcccle
+       opt/bin/aticonfig
+       opt/bin/atiodcli
+       opt/bin/atiode
+       opt/bin/clinfo
+       opt/bin/fglrxinfo
+       opt/sbin/atieventsd
+       opt/sbin/amdnotifyui
+       usr/lib\(32\|64\)\?/libaticalcl.so
+       usr/lib\(32\|64\)\?/libaticalrt.so
+       usr/lib\(32\|64\)\?/libatiuki.so.1.0
+       usr/lib\(32\|64\)\?/libatiadlxx.so
+       usr/lib\(32\|64\)\?/libfglrx_dm.so.1.0
+       usr/lib\(32\|64\)\?/libXvBAW.so.1.0
+       usr/lib\(32\|64\)\?/libAMDXvBA.so.1.0
+       usr/lib\(32\|64\)\?/xorg/modules/amdxmm.so
+       usr/lib\(32\|64\)\?/xorg/modules/glesx.so
+       usr/lib\(32\|64\)\?/xorg/modules/linux/libfglrxdrm.so
+       usr/lib\(32\|64\)\?/xorg/modules/drivers/fglrx_drv.so
+       usr/lib\(32\|64\)\?/libaticaldd.so
+       usr/lib\(32\|64\)\?/dri/fglrx_dri.so
+       usr/lib\(32\|64\)\?/opengl/ati/extensions/libglx.so
+       usr/lib\(32\|64\)\?/opengl/ati/extensions/fglrx-libglx.so
+       usr/lib\(32\|64\)\?/opengl/ati/lib/fglrx-libGL.so.1.2
+       usr/lib\(32\|64\)\?/opengl/ati/lib/libGL.so.1.2
+       usr/lib\(32\|64\)\?/libamdocl\(32\|64\)\?.so
+       usr/lib\(32\|64\)\?/libOpenCL.so.1
+"
+
+_check_kernel_config() {
+       local failed=0
+       local error=""
+       if ! kernel_is ge 2 6; then
+               eerror "You need a 2.6 linux kernel to compile against!"
+               die "No 2.6 Kernel found"
+       fi
+
+       if ! linux_chkconfig_present MTRR; then
+               ewarn "You don't have MTRR support enabled in the kernel."
+               ewarn "Direct rendering will not work."
+       fi
+
+       if linux_chkconfig_builtin DRM; then
+               ewarn "You have DRM support built in to the kernel"
+               ewarn "Direct rendering will not work."
+       fi
+
+       if ! linux_chkconfig_present AGP && \
+               ! linux_chkconfig_present PCIEPORTBUS; then
+               ewarn "You don't have AGP and/or PCIe support enabled in the kernel"
+               ewarn "Direct rendering will not work."
+       fi
+
+       if ! linux_chkconfig_present ACPI; then
+               eerror "${P} requires the ACPI support in the kernel"
+               eerror "Please enable it:"
+               eerror "    CONFIG_ACPI=y"
+               eerror "in /usr/src/linux/.config or"
+               eerror "    Power management and ACPI options --->"
+               eerror "        [*] Power Management support"
+               eerror "in the 'menuconfig'"
+               error+=" CONFIG_ACPI disabled;"
+               failed=1
+       fi
+
+       if ! linux_chkconfig_present PCI_MSI; then
+               eerror "${P} requires MSI in the kernel."
+               eerror "Please enable it:"
+               eerror "    CONFIG_PCI_MSI=y"
+               eerror "in /usr/src/linux/.config or"
+               eerror "    Bus options (PCI etc.)  --->"
+               eerror "        [*] Message Signaled Interrupts (MSI and MSI-X)"
+               eerror "in the kernel config."
+               error+=" CONFIG_PCI_MSI disabled;"
+               failed=1
+       fi
+
+       if linux_chkconfig_present LOCKDEP; then
+               eerror "You've enabled LOCKDEP -- lock tracking -- in the kernel."
+               eerror "Unfortunately, this option exports the symbol lock_acquire as GPL-only."
+               eerror "This prevents ${P} from compiling with an error like this:"
+               eerror "FATAL: modpost: GPL-incompatible module fglrx.ko uses GPL-only symbol 'lock_acquire'"
+               eerror "Please make sure the following options have been unset:"
+               eerror "    Kernel hacking  --->"
+               eerror "        [ ] Lock debugging: detect incorrect freeing of live locks"
+               eerror "        [ ] Lock debugging: prove locking correctness"
+               eerror "        [ ] Lock usage statistics"
+               eerror "in 'menuconfig'"
+               error+=" LOCKDEP enabled;"
+               failed=1
+       fi
+
+       use amd64 && if ! linux_chkconfig_present COMPAT; then
+               eerror "${P} requires COMPAT."
+               eerror "Please enable the 32 bit emulation:"
+               eerror "Executable file formats / Emulations  --->"
+               eerror "    [*] IA32 Emulation"
+               eerror "in the kernel config."
+               eerror "if this doesn't enable CONFIG_COMPAT add"
+               eerror "    CONFIG_COMPAT=y"
+               eerror "in /usr/src/linux/.config"
+               error+=" COMPAT disabled;"
+               failed=1
+       fi
+
+       kernel_is ge 2 6 37 && kernel_is le 2 6 38 && if ! linux_chkconfig_present BKL ; then
+               eerror "${P} requires BKL."
+               eerror "Please enable the Big Kernel Lock:"
+               eerror "Kernel hacking  --->"
+               eerror "    [*] Big Kernel Lock"
+               eerror "in the kernel config."
+               eerror "or add"
+               eerror "    CONFIG_BKL=y"
+               eerror "in /usr/src/linux/.config"
+               error+=" BKL disabled;"
+               failed=1
+       fi
+
+       [[ ${failed} -ne 0 ]] && die "${error}"
+}
+
+pkg_pretend() {
+       # workaround until bug 365543 is solved
+       if use modules; then
+               linux-info_pkg_setup
+               require_configured_kernel
+               _check_kernel_config
+       fi
+}
+
+pkg_setup() {
+       if use modules; then
+               MODULE_NAMES="fglrx(video:${S}/${FOLDER_PREFIX}/lib/modules/fglrx/build_mod/2.6.x)"
+               BUILD_TARGETS="kmod_build"
+               linux-mod_pkg_setup
+               BUILD_PARAMS="GCC_VER_MAJ=$(gcc-major-version) KVER=${KV_FULL} KDIR=${KV_DIR}"
+               BUILD_PARAMS="${BUILD_PARAMS} CFLAGS_MODULE+=\"-DMODULE -DATI -DFGL\""
+               if grep -q arch_compat_alloc_user_space ${KV_DIR}/arch/x86/include/asm/compat.h ; then
+                       BUILD_PARAMS="${BUILD_PARAMS} CFLAGS_MODULE+=-DCOMPAT_ALLOC_USER_SPACE=arch_compat_alloc_user_space"
+               else
+                       BUILD_PARAMS="${BUILD_PARAMS} CFLAGS_MODULE+=-DCOMPAT_ALLOC_USER_SPACE=compat_alloc_user_space"
+               fi
+       fi
+       # Define module dir.
+       MODULE_DIR="${S}/${FOLDER_PREFIX}/lib/modules/fglrx/build_mod"
+       # get the xorg-server version and set BASE_DIR for that
+       BASE_DIR="${S}/xpic"
+
+       # amd64/x86
+       if use amd64 ; then
+               MY_BASE_DIR="${BASE_DIR}_64a"
+               PKG_LIBDIR=lib64
+               ARCH_DIR="${S}/arch/x86_64"
+       else
+               MY_BASE_DIR="${BASE_DIR}"
+               PKG_LIBDIR=lib
+               ARCH_DIR="${S}/arch/x86"
+       fi
+
+       elog
+       elog "Please note that this driver supports only graphic cards based on"
+       elog "r600 chipset and newer."
+       elog "This represent the ATI Radeon HD series at this moment."
+       elog
+       elog "If your card is older then usage of ${CATEGORY}/xf86-video-ati"
+       elog "as replacement is highly recommended. Rather than staying with"
+       elog "old versions of this driver."
+       elog "For migration informations please reffer to:"
+       elog "http://www.gentoo.org/proj/en/desktop/x/x11/ati-migration-guide.xml"
+       einfo
+}
+
+src_unpack() {
+       if [[ $(get_major_version) -gt 8 ]]; then
+               # Switching to a standard way to extract the files since otherwise no signature file
+               # would be created
+               local src="${DISTDIR}/${A}"
+               sh "${src}" --extract "${S}"  2&>1 /dev/null
+       else
+               unpack ${A}
+       fi
+}
+
+src_prepare() {
+       # All kernel options for prepare are ment to be in here
+       if use modules; then
+               # version patches
+               # epatch "${FILESDIR}"/kernel/${PV}-*.patch
+               if use debug; then
+                       sed -i '/^#define DRM_DEBUG_CODE/s/0/1/' \
+                               "${MODULE_DIR}/firegl_public.c" \
+                               || die "Failed to enable debug output."
+               fi
+       fi
+
+       # These are the userspace utilities that we also have source for.
+       # We rebuild these later.
+       rm \
+               "${ARCH_DIR}"/usr/X11R6/bin/fgl_glxgears \
+               || die "bin rm failed"
+
+       # in this version amdcccle isn't static, thus we depend on qt4
+       use qt4 || rm "${ARCH_DIR}"/usr/X11R6/bin/amdcccle
+
+       # ACPI fixups
+       sed -i \
+               -e "s:/var/lib/xdm/authdir/authfiles/:/var/run/xauth/:" \
+               -e "s:/var/lib/gdm/:/var/gdm/:" \
+               "${S}/${FOLDER_PREFIX}etc/ati/authatieventsd.sh" \
+               || die "sed failed."
+
+       # Since "who" is in coreutils, we're using that one instead of "finger".
+       sed -i -e 's:finger:who:' \
+               "${S}/${FOLDER_PREFIX}usr/share/doc/fglrx/examples/etc/acpi/ati-powermode.sh" \
+               || die "Replacing 'finger' with 'who' failed."
+       # Adjust paths in the script from /usr/X11R6/bin/ to /opt/bin/ and
+       # add function to detect default state.
+       epatch "${FILESDIR}"/ati-powermode-opt-path-2.patch || die "Failed to epatch powermode-opt-path-2.patch"
+
+       cd "${MODULE_DIR}"
+
+       # bugged fglrx build system, this file should be copied by hand
+       cp ${ARCH_DIR}/lib/modules/fglrx/build_mod/libfglrx_ip.a 2.6.x
+
+       convert_to_m 2.6.x/Makefile || die "convert_to_m failed"
+
+       # When built with ati's make.sh it defines a bunch of macros if
+       # certain .config values are set, falling back to less reliable
+       # detection methods if linux/autoconf.h is not available. We
+       # simply use the linux/autoconf.h settings directly, bypassing the
+       # detection script.
+       sed -i -e 's/__SMP__/CONFIG_SMP/' *.c *h || die "SMP sed failed"
+       sed -i -e 's/ifdef MODVERSIONS/ifdef CONFIG_MODVERSIONS/' *.c *.h \
+               || die "MODVERSIONS sed failed"
+       cd "${S}"
+
+       mkdir extra || die "mkdir failed"
+       cd extra
+       unpack ./../${FOLDER_PREFIX}usr/src/ati/fglrx_sample_source.tgz
+}
+
+src_compile() {
+       use modules && linux-mod_src_compile
+
+       ebegin "Building fgl_glxgears"
+       cd "${S}"/extra/fgl_glxgears
+       # These extra libs/utils either have an Imakefile that does not
+       # work very well without tweaking or a Makefile ignoring CFLAGS
+       # and the like. We bypass those.
+src_test() { :; } # no tests present
+       # The -DUSE_GLU is needed to compile using nvidia headers
+       # according to a comment in ati-drivers-extra-8.33.6.ebuild.
+       "$(tc-getCC)" -o fgl_glxgears ${CFLAGS} ${LDFLAGS} -DUSE_GLU \
+               -I"${S}"/${FOLDER_PREFIX}usr/include fgl_glxgears.c \
+               -lGL -lGLU -lX11 -lm || die "fgl_glxgears build failed"
+       eend $?
+}
+
+src_test() { :; } # no tests presentsrc_test() { :; } # no tests present
+
+src_install() {
+       use modules && linux-mod_src_install
+
+       # We can do two things here, and neither of them is very nice.
+
+       # For direct rendering libGL has to be able to load one or more
+       # dri modules (files ending in _dri.so, like fglrx_dri.so).
+       # Gentoo's mesa looks for these files in the location specified by
+       # LIBGL_DRIVERS_PATH or LIBGL_DRIVERS_DIR, then in the hardcoded
+       # location /usr/$(get_libdir)/dri. Ati's libGL does the same
+       # thing, but the hardcoded location is /usr/X11R6/lib/modules/dri
+       # on x86 and amd64 32bit, /usr/X11R6/lib64/modules/dri on amd64
+       # 64bit. So we can either put the .so files in that (unusual,
+       # compared to "normal" mesa libGL) location or set
+       # LIBGL_DRIVERS_PATH. We currently do the latter. See also bug
+       # 101539.
+
+       # The problem with this approach is that LIBGL_DRIVERS_PATH
+       # *overrides* the default hardcoded location, it does not extend
+       # it. So if ati-drivers is merged but a non-ati libGL is selected
+       # and its hardcoded path does not match our LIBGL_DRIVERS_PATH
+       # (because it changed in a newer mesa or because it was compiled
+       # for a different set of multilib abis than we are) stuff breaks.
+
+       # We create one file per ABI to work with "native" multilib, see
+       # below.
+
+       echo "COLON_SEPARATED=LIBGL_DRIVERS_PATH" > "${T}/03ati-colon-sep"
+       doenvd "${T}/03ati-colon-sep" || die
+
+       # All libraries that we have a 32 bit and 64 bit version of on
+       # amd64 are installed in src_install-libs. Everything else
+       # (including libraries only available in native 64bit on amd64)
+       # goes in here.
+
+       # There used to be some code here that tried to detect running
+       # under a "native multilib" portage ((precursor of)
+       # http://dev.gentoo.org/~kanaka/auto-multilib/). I removed that, it
+       # should just work (only doing some duplicate work). --marienz
+       if has_multilib_profile; then
+               local OABI=${ABI}
+               for ABI in $(get_install_abis); do
+                       src_install-libs
+               done
+               ABI=${OABI}
+               unset OABI
+       else
+               src_install-libs
+       fi
+
+       # This is sorted by the order the files occur in the source tree.
+
+       # X modules.
+       exeinto /usr/$(get_libdir)/xorg/modules/drivers
+       doexe "${MY_BASE_DIR}"/usr/X11R6/${PKG_LIBDIR}/modules/drivers/fglrx_drv.so
+       exeinto /usr/$(get_libdir)/xorg/modules/linux
+       doexe "${MY_BASE_DIR}"/usr/X11R6/${PKG_LIBDIR}/modules/linux/libfglrxdrm.so
+       exeinto /usr/$(get_libdir)/xorg/modules
+       doexe "${MY_BASE_DIR}"/usr/X11R6/${PKG_LIBDIR}/modules/{glesx.so,amdxmm.so}
+
+       # Arch-specific files.
+       # (s)bin.
+       into /opt
+       dosbin "${ARCH_DIR}"/usr/sbin/atieventsd
+       use qt4 && dosbin "${ARCH_DIR}"/usr/sbin/amdnotifyui
+       use opencl && dobin "${ARCH_DIR}"/usr/bin/clinfo
+       # We cleaned out the compilable stuff in src_unpack
+       dobin "${ARCH_DIR}"/usr/X11R6/bin/*
+
+       # Common files.
+       # etc.
+       insinto /etc/ati
+       exeinto /etc/ati
+       # Everything except for the authatieventsd.sh script.
+       doins ${FOLDER_PREFIX}etc/ati/{logo*,control,atiogl.xml,signature,amdpcsdb.default}
+       doexe ${FOLDER_PREFIX}etc/ati/authatieventsd.sh
+       # OpenCL
+       if use opencl ; then
+               insinto /etc/OpenCL/vendors/
+               doins "${ARCH_DIR}"/etc/OpenCL/vendors/amdocl64.icd || die "doins failed"
+       fi
+
+       # include.
+       insinto /usr
+       doins -r ${FOLDER_PREFIX}usr/include
+       insinto /usr/include/X11/extensions
+
+       # Just the atigetsysteminfo.sh script.
+       into /usr
+       dosbin ${FOLDER_PREFIX}usr/sbin/*
+
+       # data files for the control panel.
+       if use qt4 ; then
+               insinto /usr/share
+               doins -r ${FOLDER_PREFIX}usr/share/ati
+               insinto /usr/share/pixmaps
+               doins ${FOLDER_PREFIX}usr/share/icons/ccc_large.xpm
+               make_desktop_entry amdcccle 'ATI Catalyst Control Center' \
+                       ccc_large System
+       fi
+
+       # doc.
+       dohtml -r ${FOLDER_PREFIX}usr/share/doc/fglrx
+
+       doman ${FOLDER_PREFIX}usr/share/man/man8/atieventsd.8
+
+       pushd ${FOLDER_PREFIX}usr/share/doc/fglrx/examples/etc/acpi > /dev/null
+
+       exeinto /etc/acpi
+       doexe ati-powermode.sh
+       insinto /etc/acpi/events
+       doins events/*
+
+       popd > /dev/null
+
+       # Done with the "source" tree. Install tools we rebuilt:
+       dobin extra/fgl_glxgears/fgl_glxgears
+       newdoc extra/fgl_glxgears/README README.fgl_glxgears
+
+       # Gentoo-specific stuff:
+       newinitd "${FILESDIR}"/atieventsd.init atieventsd
+       echo 'ATIEVENTSDOPTS=""' > "${T}"/atieventsd.conf
+       newconfd "${T}"/atieventsd.conf atieventsd
+
+       # PowerXpress stuff
+       exeinto /usr/$(get_libdir)/fglrx
+       doexe "${FILESDIR}"/switchlibGL || die "doexe switchlibGL failed"
+       cp "${FILESDIR}"/switchlibGL "${T}"/switchlibglx
+       doexe "${T}"/switchlibglx || die "doexe switchlibglx failed"
+}
+
+src_install-libs() {
+       if [[ "${ABI}" == "amd64" ]]; then
+               local EX_BASE_DIR="${BASE_DIR}_64a"
+               local pkglibdir=lib64
+               local MY_ARCH_DIR="${S}/arch/x86_64"
+       else
+               local EX_BASE_DIR="${BASE_DIR}"
+               local pkglibdir=lib
+               local MY_ARCH_DIR="${S}/arch/x86"
+       fi
+       einfo "ati tree '${pkglibdir}' -> '$(get_libdir)' on system"
+
+       local ATI_ROOT=/usr/$(get_libdir)/opengl/ati
+       # To make sure we do not miss a spot when these change.
+       local libmajor=1 libminor=2
+       local libver=${libmajor}.${libminor}
+
+       # The GLX libraries
+       # (yes, this really is "lib" even on amd64/multilib --marienz)
+       exeinto ${ATI_ROOT}/lib
+       newexe "${MY_ARCH_DIR}"/usr/X11R6/${pkglibdir}/fglrx/fglrx-libGL.so.${libver} \
+               libGL.so.${libver}
+       dosym libGL.so.${libver} ${ATI_ROOT}/lib/libGL.so.${libmajor}
+       dosym libGL.so.${libver} ${ATI_ROOT}/lib/libGL.so
+
+       exeinto ${ATI_ROOT}/extensions
+       doexe "${EX_BASE_DIR}"/usr/X11R6/${pkglibdir}/modules/extensions/fglrx/fglrx-libglx.so
+       mv "${D}"/${ATI_ROOT}/extensions/{fglrx-,}libglx.so
+
+       # other libs
+       exeinto /usr/$(get_libdir)
+       # Everything except for the libGL.so installed some row above
+       doexe $(find "${MY_ARCH_DIR}"/usr/X11R6/${pkglibdir} \
+               -maxdepth 1 -type f -name '*.so*' -not -name '*libGL.so*')
+       insinto /usr/$(get_libdir)
+       doins $(find "${MY_ARCH_DIR}"/usr/X11R6/${pkglibdir} \
+               -maxdepth 1 -type f -not -name '*.so*')
+
+       # DRI modules, installed into the path used by recent versions of mesa.
+       exeinto /usr/$(get_libdir)/dri
+       doexe "${MY_ARCH_DIR}"/usr/X11R6/${pkglibdir}/modules/dri/fglrx_dri.so
+
+       # AMD Cal and OpenCL libraries
+       exeinto /usr/$(get_libdir)
+       if use opencl ; then
+               doexe "${MY_ARCH_DIR}"/usr/${pkglibdir}/lib*.so*
+       else
+               doexe "${MY_ARCH_DIR}"/usr/${pkglibdir}/libati*.so*
+       fi
+
+       local envname="${T}"/04ati-dri-path
+       if [[ -n ${ABI} ]]; then
+               envname="${envname}-${ABI}"
+       fi
+       echo "LIBGL_DRIVERS_PATH=/usr/$(get_libdir)/dri" > "${envname}"
+       doenvd "${envname}"
+
+       # Silence the QA notice by creating missing soname symlinks
+       for so in $(find "${D}"/usr/$(get_libdir) -maxdepth 1 -name *.so.[0-9].[0-9])
+       do
+               local soname=${so##*/}
+               ## let's keep also this alternative way ;)
+               #dosym ${soname} /usr/$(get_libdir)/${soname%.[0-9]}
+               dosym ${soname} /usr/$(get_libdir)/$(scanelf -qF "#f%S" ${so})
+       done
+}
+
+pkg_postinst() {
+       elog "To switch to ATI OpenGL, run \"eselect opengl set ati\""
+       elog "To change your xorg.conf you can use the bundled \"aticonfig\""
+       elog
+       elog "If you experience unexplained segmentation faults and kernel crashes"
+       elog "with this driver and multi-threaded applications such as wine,"
+       elog "set UseFastTLS in xorg.conf to either 0 or 1, but not 2."
+       elog
+       elog "Fully rebooting the system after an ${PN} update is recommended"
+       elog "Stopping Xorg, reloading fglrx kernel module and restart Xorg"
+       elog "might not work"
+
+       use modules && linux-mod_pkg_postinst
+       "${ROOT}"/usr/bin/eselect opengl set --use-old ati
+}
+
+pkg_preinst() {
+       use modules && linux-mod_pkg_preinst
+}
+
+pkg_prerm() {
+       "${ROOT}"/usr/bin/eselect opengl set --use-old xorg-x11
+}
+
+pkg_postrm() {
+       use modules && linux-mod_pkg_postrm
+       "${ROOT}"/usr/bin/eselect opengl set --use-old xorg-x11
+}
index 841140747700ffc9923e9ac49179997de2d33cdc..3063763e24336f0b2d5b89323e527decff03031f 100644 (file)
@@ -11,6 +11,9 @@
            <description>Proxied co-maintainer</description>
        </maintainer>
        <use>
+               <flag name='opencl'>
+                       Install OpenCL libraries
+               </flag>
                <flag name='qt4'>
                        Install qt4 dependent optional tools (e.g Catalyst Control Panel)
                </flag>